#include <stdlib.h>
#include <math.h>
#include <stdio.h>

#include "hmm-gene.h"


main(int argc, char *argv[])
{
    /* HMM$B$K$h$C$F!$(BDNA$B$N3X=,MQG[Ns72$rDj<02=$9$k!%(B
       $BDj<02=$O!$(Bmotif$BG[Ns!$(Bmotif$B4V5wN%!$%/%i%9%?%j%s%0$G9T$J$o$l$k!%(B
       HMM$B$N%"!<%-%F%/%A%c(B($B%M%C%H%o!<%/9=B$$H%Q%i%a!<%?%;%C%H(B)$B$O!$(B
       GA$B$K$h$C$F:GE,2=$5$l$k!%(B */


#ifdef DEBUG
    int i;
#endif

    int ga();

    double rtime, ctime;
    double timer_getrtime(), timer_getutime(), timer_getstime();


    /* Timer$B$N(Bstart$B!%(B */
    timer_start();


    /* GA$B$K$h$C$F!$3X=,MQ(BDNA$BG[Ns72$r:G$bNI9%$KI=8=$9$k$h$&$K(B
       HMM$B$N%"!<%-%F%/%A%c$r:GE,2=$9$k!%(B */
#ifdef DEBUG
    fprintf(stderr, "--- optimizing an architecture of HMM using GA...\n");
#endif
    if(ga() != 0){
	fprintf(stderr, "error occures in ga()...\n");
	exit(-1);
    }


    /* Timer$B$N(Bstop$B!%(B */
    timer_stop();
    rtime = timer_getrtime();
    ctime = timer_getutime() + timer_getstime();
    fprintf(stderr, "real time(sec) = %f\n", rtime);
    fprintf(stderr, "cpu time(sec) = %f\n", ctime);
    fflush(stderr);
    fprintf(stdout, "real time(sec) = %f\n", rtime);
    fprintf(stdout, "cpu time(sec) = %f\n", ctime);
    fflush(stdout);


#ifdef DEBUG
    fprintf(stderr, "--- normal end, see you...\n");
#endif


    exit(0);
}


